#include <glad/glad.h>
#include <GLFW/glfw3.h>

#include <coil/coil.hpp>
#include <coil/segment.hpp>
#include <utils/utils.hpp>

Coil::Coil(uint32_t currentYear, uint32_t amountOfSegments) 
	: currentYear(currentYear) {
	for (short i = amountOfSegments / -2.; i < amountOfSegments / 2.; i++) {
		uint32_t year = this->currentYear + i;
    	segments.push_back(CoilSegment(this, year, segmentHeight, i, 3,false));
	}
};

std::vector<CoilSegment> &Coil::getSegments() {
	return segments;
}

double Coil::getWidth() {
	return width;
}

void Coil::render() {
	prepareShaders();
	uint64_t VBO;
	glGenBuffers(1, (unsigned int*) &(VBO));
	glBindBuffer(GL_ARRAY_BUFFER, VBO); 
	for (CoilSegment segment : segments) {
		double* vertices = segment.getVertices();
		uint64_t verticesLength = segment.getVerticesLength();
		glBufferData(GL_ARRAY_BUFFER, verticesLength, vertices, GL_STATIC_DRAW);
		

	}
}