#include <vector>
#include "segment.hpp"

#ifndef COIL_HPP 
#define COIL_HPP

// Coil segment is a one turn of a coil
// Coil slice is a set of points that define slice of coil

class Coil {
    // distance between coil center and nearest to it coil edge 
    double radius;
    // distance between coil slices edges
    double width;
    double segmentHeight;
    uint32_t currentYear;
    std::vector<CoilSegment> segments;

    public:
    Coil(uint32_t currentYear, uint32_t amountOfSegments);
    std::vector<CoilSegment> &getSegments();
    double getWidth();
    void render();
};

#endif // COIL_HPP