#ifndef COIL_SEGMENT_HPP
#define COIL_SEGMENT_HPP

#include <cstdint>

class Coil;

class CoilSegment {
    Coil *coil;
    uint16_t year;
    uint16_t height;
    // Number of a segments, counting from the central (which is 0)
    int shift;
    uint32_t sliceDetalization;
    bool isLeap;
    double *vertices;
    uint64_t verticesLength;

    void init();
    double* calculateSlice();
    void constructSegment(double *slice);

    public:
    CoilSegment(Coil* coil, uint16_t year, uint16_t height, int shift, uint32_t sliceDetalization, bool isLeap);
    void calculate();
    void printVertices();
    double *getVertices();
    uint64_t getVerticesLength();
    void printSlice(double *slice);
    void exportSliceToCSV(double *slice);
    void exportSegmentToCsv();
    void render();
};

#endif // COIL_SEGMENT_HPP